Halide 22.0.0 Halide compiler and libraries

Classes | Public Member Functions | Public Attributes | Static Public Attributes | List of all members
Halide::Internal::IRMatcher::Fold< A > Struct Template Reference

`#include <IRMatch.h>`

## Classes
struct | pattern_tag

## Public Member Functions
HALIDE_ALWAYS_INLINE Expr | make (MatcherState &state, halide_type_t type_hint) const noexcept
template<typename A1 = A>
HALIDE_ALWAYS_INLINE void | make_folded_const (halide_scalar_value_t &val, halide_type_t &ty, MatcherState &state) const noexcept

## Public Attributes
A | a

## Static Public Attributes
static constexpr uint32_t | binds = bindings<A>::mask
static constexpr IRNodeType | min_node_type = IRNodeType::IntImm
static constexpr IRNodeType | max_node_type = IRNodeType::FloatImm
static constexpr bool | canonical = true
static constexpr bool | foldable = A::foldable

## Detailed Description

template<typename A>
struct Halide::Internal::IRMatcher::Fold< A >

Definition at line 2253 of file IRMatch.h.

## Member Function Documentation

## ◆ make()

template<typename A >

HALIDE_ALWAYS_INLINE Expr Halide::Internal::IRMatcher::Fold< A >::make | ( | MatcherState & | state,
|  | halide_type_t | type_hint
| ) |  | const
| inline noexcept

Definition at line 2264 of file IRMatch.h.

References Halide::Internal::IRMatcher::Fold< A >::a, halide_type_t::bits, halide_type_t::code, halide_scalar_value_t::f64, halide_type_float, halide_type_int, halide_scalar_value_t::i64, Halide::Internal::IRMatcher::make_const_expr(), and halide_scalar_value_t::u.

## ◆ make_folded_const()

template<typename A >
template<typename A1 = A>

HALIDE_ALWAYS_INLINE void Halide::Internal::IRMatcher::Fold< A >::make_folded_const | ( | halide_scalar_value_t & | val,
|  | halide_type_t & | ty,
|  | MatcherState & | state
| ) |  | const
| inline noexcept

Definition at line 2289 of file IRMatch.h.

References Halide::Internal::IRMatcher::Fold< A >::a.

## Member Data Documentation

## ◆ a

template<typename A >

A Halide::Internal::IRMatcher::Fold< A >::a

Definition at line 2255 of file IRMatch.h.

Referenced by Halide::Internal::IRMatcher::Fold< A >::make(), Halide::Internal::IRMatcher::Fold< A >::make_folded_const(), and Halide::Internal::IRMatcher::operator<<().

## ◆ binds

template<typename A >

constexpr uint32_t Halide::Internal::IRMatcher::Fold< A >::binds = bindings<A>::mask
| static constexpr

Definition at line 2257 of file IRMatch.h.

## ◆ min_node_type

template<typename A >

constexpr IRNodeType Halide::Internal::IRMatcher::Fold< A >::min_node_type = IRNodeType::IntImm
| static constexpr

Definition at line 2259 of file IRMatch.h.

## ◆ max_node_type

template<typename A >

constexpr IRNodeType Halide::Internal::IRMatcher::Fold< A >::max_node_type = IRNodeType::FloatImm
| static constexpr

Definition at line 2260 of file IRMatch.h.

## ◆ canonical

template<typename A >

constexpr bool Halide::Internal::IRMatcher::Fold< A >::canonical = true
| static constexpr

Definition at line 2261 of file IRMatch.h.

## ◆ foldable

template<typename A >

constexpr bool Halide::Internal::IRMatcher::Fold< A >::foldable = A::foldable
| static constexpr

Definition at line 2286 of file IRMatch.h.

The documentation for this struct was generated from the following file:

- src/IRMatch.h